<?php
namespace Services;

class Mym00105LocalPesqService {
	protected $environment;
	protected $entityManager;
	
	public function __construct($environment, $entityManager){
        $this->environment = $environment;
        $this->entityManager = $entityManager;
	}

    public function retornaLocais($filiais, $nrlocalpesqOri) {

        try {
            $this->NRORG = $this->environment->getNrOrg();

            $sql = "SELECT NRLOCALPESQ FROM LOCALPESQ WHERE (INSTR(:CDFILIAL, CDFILIAL ) <> 0) AND (NRLOCALPESQ <> :NRLOCALPESQ) AND NRORG = :NRORG";
    
            $params = array(
                'CDFILIAL' => $filiais,
                'NRLOCALPESQ' => $nrlocalpesqOri,
                'NRORG' => $this->NRORG
            );
    
            $lista = $this->entityManager->getConnection()->fetchAll($sql, $params);
            
            return array_column($lista, "NRLOCALPESQ");
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function exportaProdutos($tipoExport, $nrlocalpesqOri,$nrlocalpesqDest, $produtos){
        try {
            $this->NRORG = $this->environment->getNrOrg();
            foreach ($nrlocalpesqDest as $local) {
                if($tipoExport == 'S'){
                    $this->deletaProduto($this->NRORG, $local);
                }
                $this->insereProdutos($tipoExport, $nrlocalpesqOri, $local, $produtos, $this->NRORG);
            }

        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function deletaProduto($nrorg, $local) {
        try {
            $sql = "DELETE FROM PRODUTOLOCALPESQ WHERE NRLOCALPESQ = :NRLOCALPESQDEST AND NRORG = :NRORG";
            $params = array(
                "NRLOCALPESQDEST" => $local,
                "NRORG" => $nrorg
            );
            $stmt = $this->entityManager->getConnection()->prepare($sql);
            $stmt->execute($params);
        } catch (\Excepition $e){
            throw $e;
        }  
        return true;
    }
    
    public function insereProdutos($tipoExport, $nrlocalpesqOri, $local, $produtos, $nrorg) {
        try {
            $sqlAcrescenta = <<<SQL
            INSERT INTO PRODUTOLOCALPESQ (NRPRODUTOLOCALPESQ, NRLOCALPESQ, CDPRODUTO, NRGRUPOPRATOPESQ, IDEXIBE, NRORDEM, VRPRECO, DSDESCRICAO, URL_FOTO, IDRESERVA)
            (SELECT RETORNA_NOVO_CODIGO('PRODUTOLOCALPESQ',1) ,:NRLOCALPESQDEST, CDPRODUTO, NRGRUPOPRATOPESQ, IDEXIBE, 
                    ROWNUM + (SELECT MAX(PL.NRORDEM) FROM PRODUTOLOCALPESQ PL WHERE PL.NRLOCALPESQ = :NRLOCALPESQDEST) AS ORDEM, VRPRECO, DSDESCRICAO, URL_FOTO, IDRESERVA
               FROM (SELECT P.CDPRODUTO, P.NRGRUPOPRATOPESQ, P.IDEXIBE, P.NRORDEM, P.VRPRECO, P.DSDESCRICAO, P.URL_FOTO, P.IDRESERVA
                       FROM PRODUTOLOCALPESQ P
                      WHERE P.NRLOCALPESQ = :NRLOCALORIGEM AND
                            INSTR(:NRPRODUTOLOCALPESQ,P.NRPRODUTOLOCALPESQ) <> 0 AND P.NRORG = :NRORG
             ORDER BY P.NRORDEM ASC))
SQL;
            $sqlSobrepoe = <<<SQL
            INSERT INTO PRODUTOLOCALPESQ (NRPRODUTOLOCALPESQ, NRLOCALPESQ, CDPRODUTO, NRGRUPOPRATOPESQ, IDEXIBE, NRORDEM, VRPRECO, DSDESCRICAO, URL_FOTO, IDRESERVA)
            (SELECT RETORNA_NOVO_CODIGO('PRODUTOLOCALPESQ',1) ,:NRLOCALPESQDEST, CDPRODUTO, NRGRUPOPRATOPESQ, IDEXIBE, ROWNUM AS ORDEM, VRPRECO, DSDESCRICAO, URL_FOTO, IDRESERVA
              FROM (SELECT P.CDPRODUTO, P.NRGRUPOPRATOPESQ, P.IDEXIBE, P.VRPRECO, P.DSDESCRICAO, P.URL_FOTO, P.IDRESERVA
                      FROM PRODUTOLOCALPESQ P
                      WHERE P.NRLOCALPESQ = :NRLOCALORIGEM AND
                            INSTR(:NRPRODUTOLOCALPESQ,P.NRPRODUTOLOCALPESQ) <> 0 AND P.NRORG = :NRORG
             ORDER BY P.NRORDEM ASC))
SQL;
            
            $params = array(
                "NRLOCALPESQDEST" => $local,
                "NRLOCALORIGEM" => $nrlocalpesqOri,
                "NRPRODUTOLOCALPESQ" => $produtos,
                "NRORG" => $nrorg
            );
            
            $sql = $tipoExport == 'A'? $sqlAcrescenta : $sqlSobrepoe;
            $stmt = $this->entityManager->getConnection()->prepare($sql);
            $stmt->execute($params);

	    } catch(\Exception $e) {
	        throw $e;
	    }
    }
}