<?php

namespace Suprimentos\Logic\Compra;
use Ambiente;
use Setforms2\Runtime\Helper\Procedure;
use Setforms2\Runtime\Helper\Procedure\Param;
use Setforms2\Shared\Registry;
use Suprimentos\Entities\Coletapr;
use Suprimentos\Entities\Compra;
use Suprimentos\Entities\Itmapurprec;

class RotinaEfetivacao{
    public static function StpApuraCompra($cdcentcmp, $nrseqapur, $dtini, $dtfin, $cdfiliproc, $cdoperlanc, $cdcomprador, $nrcompra){

        $procedure = new Procedure('APURA_COMPRA');
        $procedure->addParam(new Param('P_CDCENTCMP',   Param::PARAM_INPUT, $cdcentcmp,   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQAPUR',   Param::PARAM_INPUT, $nrseqapur,   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINI',       Param::PARAM_INPUT, $dtini,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFIN',       Param::PARAM_INPUT, $dtfin,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_FILIPROC',    Param::PARAM_INPUT, $cdfiliproc,  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_ROWSAFFECT',  Param::PARAM_OUTPUT, null,        Param::PARAM_TYPE_STR, 20));
        $procedure->addParam(new Param('P_CDOPERLANC',  Param::PARAM_INPUT, $cdoperlanc,  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCOMPRADOR', Param::PARAM_INPUT, $cdcomprador, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRCOMPRA',    Param::PARAM_INPUT, $nrcompra,    Param::PARAM_TYPE_STR));
        
        $apuracompra = $procedure->call();
        return $apuracompra['P_ROWSAFFECT'];
    }
	
	public static function StpApuraMelhorCotacao($cdcentcmp, $nrseqapur){

        $procedure = new Procedure('APURA_MELHOR_COTACAO');
        $procedure->addParam(new Param('P_CDCENTCMP',   Param::PARAM_INPUT, $cdcentcmp,   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQAPUR',   Param::PARAM_INPUT, $nrseqapur,   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_SISTEMA',     Param::PARAM_INPUT, NULL,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TIPO',        Param::PARAM_INPUT, NULL,         Param::PARAM_TYPE_STR));

        $apuramelhorcotacao = $procedure->call();
        return $apuramelhorcotacao['P_ROWSAFFECT'];
    }
	
	public static function StpEfetivarAf($cdoperlanc, $dtlancamento, $cdcentcmp, $nrseqapur, $cdfillanc){

        $procedure = new Procedure('EFETIVAR_AF');
		$procedure->addParam(new Param('P_CDOPERADOR',  Param::PARAM_INPUT, $cdoperlanc,   Param::PARAM_TYPE_STR));
		$procedure->addParam(new Param('P_DTAUTOFORN',  Param::PARAM_INPUT, $dtlancamento, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCENTCMP',   Param::PARAM_INPUT, $cdcentcmp,    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQAPUR',   Param::PARAM_INPUT, $nrseqapur,    Param::PARAM_TYPE_STR));
		$procedure->addParam(new Param('P_CDFILLANC',   Param::PARAM_INPUT, $cdfillanc,    Param::PARAM_TYPE_STR));
        
        $efetivaraf = $procedure->call();
        return $efetivaraf['P_ROWSAFFECT'];
    }
    public static function StatusCompraApurado($nrcompra){
        try{
            $nrorg = Ambiente::getNrorg();
            $compra = Compra::findOneByNrorgAndNrcompra($nrorg,$nrcompra);
            if($compra){
                $compra->setIdsitucompra('5');
                $compra->persist();
                Registry::getEntityManager()->flush();
            }
        }catch(\Exception $e){
            throw $e;
        }
    }

    public static function StatusColetaConcluida($nrcoleta,$cdcentcmp,$status){
        try{
            $nrorg = Ambiente::getNrorg();
            $coleta = Coletapr::findOneByNrorgAndNrcoleprecoAndCdfilial($nrorg,$nrcoleta,$cdcentcmp);
            if($coleta){
                $coleta->setIdsitucoleta($status);
                $coleta->persist();
                Registry::getEntityManager()->flush();
            }
        }catch(\Exception $e){
            throw $e;
        }
    }

    public static function StatusCompraGeradoOC($nrcompra){
        try{
            $nrorg = Ambiente::getNrorg();
            $compra = Compra::findOneByNrorgAndNrcompra($nrorg,$nrcompra);
            if($compra){
                $compra->setIdsitucompra('7');
                $compra->persist();
                Registry::getEntityManager()->flush();
            }
        }catch(\Exception $e){
            throw $e;
        }
    }
    public static function alteraValorAUsar($nrcompra,$cdproduto,$cdforneced){
        try{
            $efetAtual = Itmapurprec::findOneByNrcompraAndCdproditmapAndIditmselapur($nrcompra, $cdproduto, 'S');
            if($efetAtual){
                $efetAtual->setIditmselapur('N');
                $efetAtual->persist();
                $efetNovo = Itmapurprec::findOneByNrcompraAndCdproditmapAndCdfornitmap($nrcompra, $cdproduto, $cdforneced);
                if($efetNovo){
                    $efetNovo->setIditmselapur('S');
                    $efetNovo->persist();
                }
                Registry::getEntityManager()->flush();
            }
        }catch(\Exception $e){
            throw $e;
        }
    }
}