var MemoryStorageEngine = function(ZhLogger, requestDataSourceEngine, requestFactory, requestEngine, templateManager, 
	DataSourceHolder, ZHPromise, ZhUtil, Query) {
	var self = this;

	Util.extend(this, new StorageEngine(ZhUtil));
	
	self._storageMapping = {};

	self._setItem = function(name, data) {
		var newData = Util.clone(data);
		self._storageMapping[name] = newData;
		return ZHPromise.when();
	};

	self._removeAll = function(name) {
		delete self._storageMapping[name];
		return ZHPromise.when();
	};

	self.getDataSourceItems = function(name) {
		return ZHPromise.when(Util.clone(self._storageMapping[name]));
	};

	self._prepareData = function(data) {
		return data;
	};

	Util.decorateFromConstructor(self, Storageable, arguments);
	
	var _setDefaultValues = (function(widget) {
		Util.extend(widget, new Filterable(ZhUtil, Query));
	})(this);
};